<?php
if( !isset($gCms) ) exit;
if( !$this->CheckPermission('Modify Calendar') && !$this->CheckPermission('Add Calendar Events') &&
    !$this->CheckPermission('Edit My Calendar Events') ) exit;

debug_to_log('admin_ajax_deleteevent 1');
$userid = null;
if( !$this->CheckPermission('Modify Calendar') ) $userid = get_userid(FALSE) * -1 - 100;

$result = new stdClass;
$result->status = 0;
$result->msg = $this->Lang('error_unknown');

try {
    $event_id = (int)cge_utils::get_param($params,'event_id');
    $delete_children = (int)cge_utils::get_param($params,'delete_children',0);
    debug_to_log('admin_ajax_deleteevent 2');

    // get the event (make sure it's valid, and we have permission to delete it, AND that it is not a parent)
    $query = 'SELECT * FROM '.$this->events_table_name.' WHERE event_id = ?';
    $parms = array($event_id);
    if( !is_null($userid) ) {
        $query .= ' AND event_created_by = ?';
        $parms[] = $userid;
    }

    $event = $db->GetRow($query,array($event_id));
    if( !$event ) throw new Exception($this->Lang('error_eventnotfound'));
    debug_to_log('admin_ajax_deleteevent 3');

    if( !$delete_children ) {
        // now make sure it's not a parent (don't wanna leave orphaned events lying around)
        $query = 'SELECT event_id FROM '.$this->events_table_name.' WHERE event_parent_id = ?';
        $tmp = $db->GetOne($query,array($event_id));
        if( $tmp > 0 ) throw new Exception($this->Lang('error_deleteparentevent'));
    }

    // woot, we can delete the thing.
    cgcalendar_utils::delete_event($event_id);
    debug_to_log('admin_ajax_deleteevent 4');
    $result->status = 1;
    debug_to_log($result);
}
catch( Exception $e ) {
    $result->msg = $e->GetMessage();
    debug_to_log('admin_ajax_deleteevent err '.$e->GetMessage());
}

echo json_encode($result);
exit;

?>